package me.Demon.DemonHidePlayer;

import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.scheduler.BukkitRunnable;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class Gui implements Listener {

    public static String inv_title = "战争领域 - 玩家隐藏";
    public static List<UUID> CmdCooldList = new ArrayList<>();

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getView().getTitle().equals(inv_title)) {
            e.setCancelled(true);
            if (e.getRawSlot() == 2) {
                if (CmdCooldList.contains(p.getUniqueId())) {
                    p.sendMessage("操作冷却中...");
                    return;
                }
                CmdCooldList.add(p.getUniqueId());
                new BukkitRunnable() {
                    public void run() {
                        CmdCooldList.remove(p.getUniqueId());
                    }
                }.runTaskLater(Main.plugin, 120L);
                p.closeInventory();
                p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
                for (Player player : Bukkit.getOnlinePlayers()) {
                    p.hidePlayer(player);
                }
                p.sendMessage(Main.prefix + "玩家隐藏: §a开启");
            }
            if (e.getRawSlot() == 6) {
                if (CmdCooldList.contains(p.getUniqueId())) {
                    p.sendMessage("操作冷却中...");
                    return;
                }
                CmdCooldList.add(p.getUniqueId());
                new BukkitRunnable() {
                    public void run() {
                        CmdCooldList.remove(p.getUniqueId());
                    }
                }.runTaskLater(Main.plugin, 120L);
                p.closeInventory();
                p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
                for (Player player : Bukkit.getOnlinePlayers()) {
                    p.showPlayer(player);
                }
                p.sendMessage(Main.prefix + "玩家隐藏: §c关闭");
            }
            if (Main.plugin.getConfig().getBoolean("menu.button")) {
                if (e.getRawSlot() == 8) {
                    p.performCommand(Main.plugin.getConfig().getString("menu.command"));
                }
            }
        }
    }


    public static void OpenGui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 9, inv_title);
        inv.setItem(2, Glass_Pane("§a隐藏其他玩家", 5));
        inv.setItem(6, Glass_Pane("§c显示其他玩家", 14));
        if (Main.plugin.getConfig().getBoolean("menu.button")) {
            inv.setItem(8, BackMenu());
        }
        p.openInventory(inv);
    }

    public static ItemStack BackMenu() {
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§a返回选单");
        List<String> lore = new ArrayList<>();
        lore.add("§7§l★§7返回上级菜单");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack Glass_Pane(String name, int date) {
        ItemStack item = new ItemStack(160, 1, (short) date);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }
}
